/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.buff.Module
 *  fire.pb.item.Pack
 *  fire.pb.main.ConfigManager
 *  fire.pb.talk.MessageMgr
 *  fire.pb.tel.utils.GoodsSafeLocksUtils
 *  fire.pb.util.DateValidate
 *  mkdb.Procedure
 *  xbean.PetInfo
 *  xbean.PetSellCount
 *  xbean.Pod
 *  xtable.Properties
 *  xtable.Rolepetsellcount
 */
package fire.pb.pet;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.item.Pack;
import fire.pb.main.ConfigManager;
import fire.pb.pet.Module;
import fire.pb.pet.Pet;
import fire.pb.pet.PetAttr;
import fire.pb.pet.PetColumn;
import fire.pb.talk.MessageMgr;
import fire.pb.tel.utils.GoodsSafeLocksUtils;
import fire.pb.util.DateValidate;
import java.text.SimpleDateFormat;
import java.util.List;
import java.util.TreeMap;
import mkdb.Procedure;
import xbean.PetInfo;
import xbean.PetSellCount;
import xbean.Pod;
import xtable.Properties;
import xtable.Rolepetsellcount;

public class PPetSell
extends Procedure {
    private final long roleId;
    private final int petKey;

    public PPetSell(long roleId, int petKey) {
        this.roleId = roleId;
        this.petKey = petKey;
    }

    public boolean process() {
        if (fire.pb.buff.Module.existState((long)this.roleId, (int)507004)) {
            return false;
        }
        Integer fightPetKey = Properties.selectFightpetkey((Long)this.roleId);
        if (fightPetKey == this.petKey) {
            return false;
        }
        PetColumn petCol = new PetColumn(this.roleId, 1, false);
        Pet pet = petCol.getPet(this.petKey);
        if (null == pet) {
            return false;
        }
        if (GoodsSafeLocksUtils.checkLockStatus((long)this.roleId, (PetInfo)pet.getPetInfo())) {
            return false;
        }
        if (pet.isLocked() != -1L) {
            MessageMgr.psendMsgNotify((long)this.roleId, (int)Pet.PET_LOCK_ERROR_MSG, null);
            return true;
        }
        if (pet.getKind() != 1) {
            return false;
        }
        PetSellCount petSellCount = Rolepetsellcount.get((Long)this.roleId);
        if (petSellCount == null) {
            petSellCount = Pod.newPetSellCount();
            Rolepetsellcount.insert((Long)this.roleId, (PetSellCount)petSellCount);
        }
        if (!this.checkCount(petSellCount)) {
            MessageMgr.psendMsgNotify((long)this.roleId, (int)160405, null);
            return false;
        }
        if (!this.award(pet.getBaseId())) {
            return false;
        }
        this.addCount(petSellCount);
        if (petCol.removePet(pet.getPetkey(), 6) != 0) {
            return false;
        }
        if (Module.logger.isInfoEnabled()) {
            long resetTime = petSellCount.getResettime();
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String strTime = resetTime > 0L ? dateFormat.format(resetTime) : "0";
            Module.logger.info((Object)("[PPetSell] roleId:" + this.roleId + " petKey:" + this.petKey + " uniqId:" + pet.getUniqueId() + " petId:" + pet.getBaseId() + " petSellCount:" + petSellCount.getCount() + " resetTime:" + strTime));
        }
        GoodsSafeLocksUtils.doClearDataWhileCommit((long)this.roleId);
        return true;
    }

    private boolean checkCount(PetSellCount petSellCount) {
        long now = System.currentTimeMillis();
        if (!DateValidate.inTheSameDay((long)now, (long)petSellCount.getResettime())) {
            petSellCount.setCount(0);
            petSellCount.setResettime(now);
        }
        return petSellCount.getCount() < 10;
    }

    private void addCount(PetSellCount petSellCount) {
        petSellCount.setCount(petSellCount.getCount() + 1);
    }

    private boolean award(int petId) {
        Pack bag;
        int money = 0;
        TreeMap mapConfig = ConfigManager.getInstance().getConf(PetAttr.class);
        if (mapConfig != null) {
            for (PetAttr conf : mapConfig.values()) {
                if (conf.getId() != petId) continue;
                if (conf.getSellPrice() <= 0) break;
                money = conf.getSellPrice();
                break;
            }
        }
        if (money != 0 && (bag = new Pack(this.roleId, false)).addSysMoney((long)money, "Pet sell", YYLoggerTuJingEnum.tujing_Value_peiyang, 0) != (long)money) {
            return false;
        }
        MessageMgr.psendMsgNotify((long)this.roleId, (int)160049, (List)MessageMgr.getStringList((Object[])new Object[]{money}));
        return true;
    }
}

